/*
	Author     : AA-Team - http://themeforest.net/user/AA-Team
*/

// Initialization and events code for the app
css_picker = (function ($) {
    "use strict";

    
    var fieldsToWriteSelector 	=		[ '#custom_css_selector', '#custom_css_woocommerce_selector' ],
    	timeoutToChoose 		= 		null,
		decideHtml 				= 		null,
		pickerHtml 				= 		null,
		backToSettingsHtml 		= 		null,
		postType 				=		null,
		cbSelectorSet 			=		null,
		cbField 				=		null,
		hoveredPosition 		= 		null;

    // get query strings 

    $.extend({
      getUrlVars: function(){
        var vars = [], hash;
        var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
        for(var i = 0; i < hashes.length; i++)
        {
          hash = hashes[i].split('=');
          vars.push(hash[0]);
          vars[hash[0]] = hash[1];
        }
        return vars;
      },
      getUrlVar: function(name){
        return $.getUrlVars()[name];
      }
    });

    $.fn.extend({
	    getPath: function() {
	        var pathes = [];

	        this.each(function(index, element) {
	            var path, $node = jQuery(element);

	            while ($node.length) {
	                var realNode = $node.get(0), name = realNode.localName;
	                if (!name) { break; }

	                name = name.toLowerCase();
	                var parent = $node;
	                var sameTagSiblings = parent.children(name);

	                if (sameTagSiblings.length > 1)
	                {
	                    var allSiblings = parent.children();
	                    var index = allSiblings.index(realNode) +1;
	                    if (index > 0) {
	                        name += ':nth-child(' + index + ')';
	                    }
	                }

	                path = name + (path ? ' > ' + path : '');
	                $node = parent;
	            }

	            pathes.push(path);
	        });

	        return pathes.join(',');
	    }
	});


    // init function, autoload
    (function init() {

    	// add buttons in backend
        
    	if ( $( fieldsToWriteSelector[0] ).length > 0 ) {
    		var parent = $( fieldsToWriteSelector[0] ).parent();

    		parent.append('<a href="' + cb_home_url + '?post_type=post&cb_css_picker=1&cb_field=custom_css_selector" class="cb-button yellow">Get CSS selector from frontend</a>');
    	}

    	if ( $( fieldsToWriteSelector[1] ).length > 0 ) {
    		var parent = $( fieldsToWriteSelector[1] ).parent();

    		parent.append('<a href="' + cb_home_url + '?post_type=product&cb_css_picker=1&cb_field=custom_css_woocommerce_selector" class="cb-button yellow">Get CSS selector from frontend</a>');
    	}
	    

        // load the triggers
        $(document).ready(function(){

		    // Get object of URL parameters
		    var allVars = $.getUrlVars();

		    // Getting URL var by its name
		    var cbCssPicker = $.getUrlVar('cb_css_picker');
		    cbField =  $.getUrlVar('cb_field');
		    cbSelectorSet =  $.getUrlVar('cb_selector_set');

        	if ( cbCssPicker == '1' ) {
        		triggers();

        		pickerHtml = $( addPickerHtml() );
        		$( 'body' ).append( pickerHtml );

        		pickerHtml.css('top', '100px');
				pickerHtml.css('left', '50px');

				

				if ( cbSelectorSet != null ) {
					pickerHtml.text('Breadcrumbs container was replaced. If you want to change it, you may still can.')

					backToSettingsHtml = $( backToSettingsHtml() );

					$('body').append( backToSettingsHtml );

					backToSettingsHtml.css('top', '200px');
					backToSettingsHtml.css('left', '100px');

				}

        	}

        });


        function triggers() {

        	// ensure navigation to other page

        	$(document).on('click', 'a', function(e){
    			e.stopPropagation();
    			e.preventDefault();

    			var that 	= 	$(this);

    			var _url 		= 	that.attr('href');
			    _url 		+= 	(_url.split('?')[1] ? '&':'?') + 'cb_css_picker=1&cb_field=' + cbField;

    			window.location.replace( _url );

    			return false;
    		});


        	// display border upon hovering on elements

        	$(document).on('mouseenter', 'div:not(.cb-css-picker-container, .cb-css-picker-initial-container, .cb-css-picker-initial-message, .cb-css-picker-return, .cb-css-picker-return-message), ul', function(e){
        		e.stopPropagation();

    			var that 				= 			$(this);

    			if( !that.hasClass('cb-css-picker-decide') && !that.hasClass('cb-css-picker-container') ) {
    				$('.cb-color-picker-hovered').each( function(){
    					$(this).removeClass('cb-color-picker-hovered');
    				});
    				that.addClass('cb-color-picker-hovered');
    			}

    			// if not choosed already, ask him to choose
    			
				clearTimeout( timeoutToChoose );

				timeoutToChoose = setTimeout( function(){

				if ( $('.cb-css-picker-decide').length == 0 ){
					decideHtml = $( addDecideHtml() );
					pickerHtml.remove();
					hoveredPosition = that.offset(); 

					$('body').append( decideHtml );
				}

				// get hovered container pos

				var mouseX = e.pageX; 
				var mouseY = e.pageY - that.height();


				decideHtml.css('left', mouseX + 'px');
				decideHtml.css('top', mouseY + 'px');


				}, 1000);


    		});

        	// hide upon mouseleave

    		$(document).on('mouseleave', 'div, ul', function(e){

    			var that 	= 	$(this);

    			that.removeClass('cb-color-picker-hovered');

    			clearTimeout( timeoutToChoose );

    		});

    		// confirm container chosen

    		// send to WP Ajax and save the setting for selector

    		$(document).on('click', '.cb-color-picker-hovered', function(e){
    			e.preventDefault();

    			var that = $(this);
    			var cssSelector = that.getPath();

    			pickerHtml.remove();

    			if( decideHtml == null ) {
    				decideHtml = $( addDecideHtml() );
    				$('body').append( decideHtml );

    				// get hovered container pos

					var mouseX = e.pageX; 
					var mouseY = e.pageY - that.height();


					decideHtml.css('left', mouseX + 'px');
					decideHtml.css('top', mouseY + 'px');

    			}

    			$.ajax({
					url: cb_css_picker_utils.cb_ajax_url,
					dataType: "json",
					method: 'post',
					data: {
						action: 'cb_action_frontend',
						css_selector: cssSelector,
						cb_field: cbField
					},
					// Handle the successful result
					success: function( response ) {
						if( response.status == 'valid' ){
							setTimeout( function(){

								decideHtml.text('Great, now refreshing!');

							}, 700);

							

							setTimeout( function(){

								var currentURL = window.location.href;


								if ( cbSelectorSet == null ){
									currentURL 		+= 	(currentURL.split('?')[1] ? '&':'?') + 'cb_selector_set=1';
								}

								window.location.replace( currentURL );


							}, 1200);

							
						}
						else {
							setTimeout( function(){
								decideHtml.text('Could not save the settings. Connection issues, maybe..?');
							}, 700);
							
						}

				
					}  
				});

    		});


    		// handle return to settings

    		$(document).on('click', '.cb-css-picker-return', function(e){
    			e.preventDefault();

    			var that = $(this);
    			
    			window.location.replace ( cb_css_picker_utils.cb_settings_url );

    		});

        }


        function addPickerHtml() {
        	var html = [];

        	html.push( '<div class="cb-css-picker-container">' );
        	html.push(		'<div class="cb-css-picker-initial-message">' );
        	html.push( 			'Let\'s replace your Theme pagination. Place your mouse over the old pagination. You may also navigate while choosing.' );
        	html.push( 		'</div>' );
        	html.push( '</div>' );


        	html = html.join('');

        	return html;
        }

        function addDecideHtml() {
        	var html = [];

        	html.push( '<div class="cb-css-picker-decide">' );
        	html.push(		'<div class="cb-css-picker-decide-message">' );
        	html.push( 			'Is this the right container? Click on it if you decided. You may also navigate while choosing.' );
        	html.push( 		'</div>' );
        	html.push( '</div>' );


        	html = html.join('');

        	return html;
        }

        function backToSettingsHtml() {
        	var html = [];

        	html.push( '<div class="cb-css-picker-return">' );
        	html.push(		'<div class="cb-css-picker-return-message">' );
        	html.push( 			'Return to breadcrumbs settings?' );
        	html.push( 		'</div>' );
        	html.push( '</div>' );


        	html = html.join('');

        	return html;
        }


    })();
    
    

   
})(jQuery);