<?php
/**
 * Amazon module return as json_encode
 * http://www.aa-team.com
 * =======================
 *
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */
echo json_encode(array(
	// create the box elements array
	'option_name' => 'cb_Import_Settings',

	'tabs' => array(
		'template' => array(
			'label' 	=> 'Layout', 
			'elements' 	=> 'admin_preview, template_default, home_title, link_text_color, current_item_text_color, hover_link_text_color, template_font_family, template_font_size, template_show_border, template_border_color'
		),
		'frontend' => array(
			'label' 	=> 'Advanced Settings', 
			'elements' 	=> 'cb_gap_number, cb_range, cb_anchor'
		),
		'theme_fixes' => array(
			'label'		=> 'Theme Fixes',
			'elements' 	=> 	'custom_css_selector' . ( class_exists( 'WooCommerce' ) ? ', custom_css_woocommerce_selector' : '' )
		)
	),

	'elements' => array(

		'admin_preview' => array(
            'type' => 'html',
            'title' => 'View BreadCrumbs',
            'html' => '
                <a href="' . ( cb()->display_demo_post_type( 'post' ) ) . '" target="_blank" class="cb-button yellow"> Blog Post</a> ' . 
                ( class_exists( 'WooCommerce' ) ? '<a href="' . ( cb()->display_demo_post_type( 'product' ) ) . '" target="_blank" class="cb-button yellow"> WooCommerce Product</a>' : '' ) 
        ),

		'template_default' => array(
            'type' => 'image_radio',
            'std' => '0',
            'size' => 'small',
            'title' => 'General Style',
            'desc' => 'The default template to be used in the frontend',
            'options' => array(
            	array(
            		'caption' => 'Template 1',
            		'img' => cb()->assetUrl('images/p1.PNG')
            	),
            	array(
            		'caption' => 'Template 2',
            		'img' => cb()->assetUrl('images/p2.PNG')
            	),
            	array(
            		'caption' => 'Template 3',
            		'img' => cb()->assetUrl('images/p3.PNG')
            	),
            	array(
            		'caption' => 'Template 4',
            		'img' => cb()->assetUrl('images/p4.PNG')
            	),
            	array(
            		'caption' => 'Template 5',
            		'img' => cb()->assetUrl('images/p5.PNG')
            	),
            	array(
            		'caption' => 'Template 6',
            		'img' => cb()->assetUrl('images/p6.PNG')
            	),
            	array(
            		'caption' => 'Template 7',
            		'img' => cb()->assetUrl('images/p7.PNG')
            	),
            	array(
            		'caption' => 'Template 8',
            		'img' => cb()->assetUrl('images/p8.PNG')
            	),
            	array(
            		'caption' => 'Template 9',
            		'img' => cb()->assetUrl('images/p9.PNG')
            	)
            )
        ),



	    'separator' => array(
	        'type' => 'text',
	        'std' => '<i class="mi-icon mi-icon-arrow-right2"></i>',
	        'size' => 'small',
	        'title' => 'Separator',
	        'force_width' => '260',
	        'desc' => 'Default: <i class="mi-icon mi-icon-arrow-right2"></i>'
	    ),

	    'home_title' => array(
	        'type' => 'text',
	        'std' => 'Homepage',
	        'size' => 'small',
	        'title' => 'Home Title',
	        'force_width' => '260',
	        'desc' => 'Default: Homepage'
	    ),

	    'link_text_color' => array(
	        'type' => 'color_picker',
	        'std' => '#ffffff',
	        'size' => 'small',
	        'title' => 'Link Text Color',
	        'force_width' => '260',
	        'desc' => 'Pick your color'
	    ),

	    'current_item_text_color' => array(
	        'type' => 'color_picker',
	        'std' => '#ffffff',
	        'size' => 'small',
	        'title' => 'Current Item (not link) Text Color',
	        'force_width' => '260',
	        'desc' => 'Pick your color'
	    ),

	    'hover_link_text_color' => array(
	        'type' => 'color_picker',
	        'std' => '#f9ca24',
	        'size' => 'small',
	        'title' => 'Hover Link Text Color',
	        'force_width' => '260',
	        'desc' => 'Pick your color'
	    ),

	    'template_font_family' => array(
	        'type'				=> 'select',
	        'std'				=> 'Heebo',
	        'options' 			=> function_exists('cb') ? cb()->getAllGfonts() : array(),
	        'title'				=> 'Font Family',
	        'desc'				=> '<div class="cb-font-preview"></div>',
	        'size'				=> 'small'
	    ),

	    'template_font_size' => array(
	        'type' => 'text',
	        'std' => '16px',
	        'size' => 'small',
	        'title' => 'Font Size',
	        'force_width' => '260',
	        'desc' => 'Default: 14px'
	    ),


	    'cb_gap_number' => array(
	       'type'				=> 'select',
	        'std'				=> '1',
	        'options' 			=> function_exists('cb') ? cb()->cb_range_to_20() : array(),
	        'title'				=> 'Gap',
	        'desc'				=> 'From how many item display gap points? Default: 3',
	        'size'				=> 'small'
	    ),

	    'cb_range' => array(
	        'type'				=> 'select',
	        'std'				=> '1',
	        'options' 			=> function_exists('cb') ? cb()->cb_range_to_20() : array(),
	        'title'				=> 'Range',
	        'desc'				=> 'Default: 5',
	        'size'				=> 'small'
	    ),

	    'cb_anchor' => array(
	       'type'				=> 'select',
	        'std'				=> '1',
	        'options' 			=> function_exists('cb') ? cb()->cb_range_to_20() : array(),
	        'title'				=> 'Anchor',
	         'desc'				=> 'Default: 1',
	        'size'				=> 'small'
	    ),

	    'custom_css_selector' => array(
            'type' => 'text',
            'std' => '',
            'force_width' => '500',
            'size' => 'small',
            'title' => 'Custom CSS Blog Selector',
            'desc' => 'Please specify the custom selector if your theme has a custom pagination implemented. Ex: <code>.fusion-blog-archive .pagination</code>'
        ),

       
        'custom_css_woocommerce_selector' => array(
            'type' => 'text',
            'std' => '',
            'force_width' => '500',
            'size' => 'small',
            'title' => 'Custom CSS WooCommerce Selector',
            'desc' => 'Please specify the custom selector if your theme has a custom WooCommerce pagination implemented. Ex: <code>.fusion-blog-archive .pagination</code>'
        )
    	
	    

	), // end elements
));
