<?php
class smartBreadcrumbsFrontpage {
    public  $options; // array containing the optionsions
    private $smartBreadcrumbs;
    public  $curr_style;
    public  $current_theme;
    
    // default type
    public $type = 'posts';

    public $the_plugin = array();

    public $settings   = array();

    public $pagination_printed = false;

    function __construct( $the_plugin=array() ) {

        $this->current_theme = wp_get_theme();

        $this->loadExtraStyles();

        $this->settings = $the_plugin->settings;
        
        add_action('loop_start', array($this, 'custom_breadcrumbs'), 10, 2 );
            

    }

public function custom_breadcrumbs( $returnArray = false ) {
    // Get the query & post information
    global $post, $wp_query;

    if ( !is_main_query() || !in_the_loop() ){
        return;
    }

    // Settings
    $separator          = trim( $this->settings['separator'] ) != "" ?  stripslashes( $this->settings['separator'] )  : ' ';
    $breadcrums_id      = 'breadcrumbs';
    $breadcrums_class   = 'breadcrumbs';
    $home_title         = trim( $this->settings['home_title'] ) != "" ? $this->settings['home_title'] : 'Homepage';
      
    // If you have any custom post types with custom taxonomies, put the taxonomy name below (e.g. product_cat)
    $custom_taxonomy    = 'product_cat';
       
       
    // Do not display on the homepage
    if ( !is_front_page() ) {

        // get current style
        $curr_style = str_replace("preview.png", '', $this->settings['template_default'], $curr_style);

        $curr_style = str_replace($this->settings['template_default'], ( 'model-' . $this->settings['template_default'] . '/' ), $curr_style );
        
        $model = str_replace("/", '', str_replace("style", '', $curr_style));

        $this->curr_style = cb()->path('ASSETS_URL', 'style/') . $curr_style . 'css.css'; 

       
        if( $this->settings['template_font_family'] != 'Arial' ){

            if( $this->settings['template_font_family'] == 'Bebas Neue Bold' ){
                echo '<link rel="stylesheet" type="text/css" href="' . cb()->path('ASSETS_URL', 'fonts/bebasneuebold/font.css') . '">' . PHP_EOL;
            }else{
                echo '<link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family=' . $this->settings['template_font_family'] . '">' . PHP_EOL;
            }
            
        }

      
        $output = '<link rel="stylesheet" type="text/css" media="all" href="' . cb()->path('ASSETS_URL', 'reset.css') . '" />' . PHP_EOL;
        $output .= '<link rel="stylesheet" type="text/css" media="all" href="' . $this->curr_style . '" />' . PHP_EOL;

        $output .= '<style type="text/css">' . PHP_EOL;

        $output .=    '.cb-breadcrumbs {margin: 10px 0px;}' . PHP_EOL;
        
        $output .=    'ul#breadcrumbs.' . ($model) . ' li {font-size: ' . ( (int) $this->settings['template_font_size'])  . 'px;}' . PHP_EOL;
        
        $output .=    'ul#breadcrumbs.' . ($model) . ' li a:link, ul#breadcrumbs.' . ($model) . ' li a:visited {color: ' . ($this->settings['link_text_color']) . ';}' . PHP_EOL;
        $output .=    'ul#breadcrumbs.' . ($model) . ' li.separator {color: ' . ($this->settings['link_text_color']) . ';}' . PHP_EOL;
        $output .=    'ul#breadcrumbs.' . ($model) . ' li a:hover {color: ' . ($this->settings['hover_link_text_color']) . ';}' . PHP_EOL;
        $output .=    'ul#breadcrumbs.' . ($model) . ' .bread-current {color: ' . ($this->settings['current_item_text_color']) . ';}' . PHP_EOL;
        $output .=    'ul#breadcrumbs {display: block; clear: both; margin-bottom: 20px; margin-top: 20px;}' . PHP_EOL;
        

        if($this->settings['template_font_family'] != 'Arial'){
            $output .= "
                ul#breadcrumbs.{$model} li {
                    font-family: '".($this->settings['template_font_family'])."', Arial, serif;
                }
            ";
        }


        $output .= '</style>' . PHP_EOL; 


        $output .= '<div class="cb-breadcrumbs">';
       
            // Build the breadcrums
            $output .= '<ul class="' . esc_attr($model) .'" id="' . esc_attr($breadcrums_id) . '" class="' . esc_attr($breadcrums_class) . '">';
               
            // Home page
            $output .= '<li class="item-home"><a class="bread-link bread-home" href="' . get_home_url() . '" title="' . esc_attr($home_title) . '">' . esc_attr($home_title) . '</a></li>';
            $output .= '<li class="separator separator-home"> ' . $separator . ' </li>';
               
            if ( is_archive() && !is_tax() && !is_category() && !is_tag() ) {
                $output .= '<li class="item-current item-archive"><div class="bread-current bread-archive">' . post_type_archive_title() . '</div></li>';
                  
            } else if ( is_archive() && is_tax() && !is_category() && !is_tag() ) {
                  
                // If post is a custom post type
                $post_type = get_post_type();
                  
                // If it is a custom post type display name and link
                if($post_type != 'post') {
                      
                    $post_type_object = get_post_type_object($post_type);
                    $post_type_archive = get_post_type_archive_link($post_type);
                  
                    $output .= '<li class="item-cat item-custom-post-type-' . esc_attr($post_type) . '"><a class="bread-cat bread-custom-post-type-' . esc_attr($post_type) . '" href="' . esc_url($post_type_archive) . '" title="' . esc_attr($post_type_object->labels->name) . '">' . esc_html($post_type_object->labels->name) . '</a></li>';
                    $output .= '<li class="separator"> ' . $separator . ' </li>';
                  
                }
                  
                $custom_tax_name = get_queried_object()->name;
                $output .= '<li class="item-current item-archive"><div class="bread-current bread-archive">' . esc_html($custom_tax_name) . '</div></li>';
                  
            } else if ( is_single() ) {
                // If post is a custom post type
                $post_type = get_post_type();
                  
                // If it is a custom post type display name and link
                if($post_type != 'post') {
                      
                    $post_type_object = get_post_type_object($post_type);
                    $post_type_archive = get_post_type_archive_link($post_type);
                  
                    $output .= '<li class="item-cat item-custom-post-type-' . esc_attr($post_type) . '"><a class="bread-cat bread-custom-post-type-' . esc_attr($post_type) . '" href="' . esc_url($post_type_archive) . '" title="' . esc_attr($post_type_object->labels->name) . '">' . esc_html($post_type_object->labels->name) . '</a></li>';
                    $output .= '<li class="separator"> ' . $separator . ' </li>';
                  
                }
                  
                // Get post category info
                $category = get_the_category();
                 
                if( !empty($category) ) {
                    // Get last category post is in
                    $tmp = array_values($category);
                    $last_category = end($tmp);
                      
                    // Get parent any categories and create array
                    $get_cat_parents = rtrim(get_category_parents($last_category->term_id, true, ','),',');
                    $cat_parents = explode(',',$get_cat_parents);
                      
                    // Loop through parent categories and store in variable $cat_display
                    $cat_display = '';
                    foreach($cat_parents as $parents) {
                        $cat_display .= '<li class="item-cat">'.$parents.'</li>';
                        $cat_display .= '<li class="separator"> ' . $separator . ' </li>';
                    }
                 
                }
                  
                // If it's a custom post type within a custom taxonomy
                $taxonomy_exists = taxonomy_exists($custom_taxonomy);
                if(empty($last_category) && !empty($custom_taxonomy) && $taxonomy_exists) {
                       
                    $taxonomy_terms = get_the_terms( $post->ID, $custom_taxonomy );
                    $cat_id         = $taxonomy_terms[0]->term_id;
                    $cat_nicename   = $taxonomy_terms[0]->slug;
                    $cat_link       = get_term_link($taxonomy_terms[0]->term_id, $custom_taxonomy);
                    $cat_name       = $taxonomy_terms[0]->name;
                   
                }
                  
                // Check if the post is in a category
                if(!empty($last_category)) {
                    $output .= $cat_display;
                    $output .= '<li class="item-current item-' . esc_attr($post->ID) . '"><div class="bread-current bread-' . esc_attr($post->ID) . '" title="' . esc_attr(get_the_title()) . '">' . esc_html(get_the_title()) . '</div></li>';
                      
                // Else if post is in a custom taxonomy
                } else if(!empty($cat_id)) {
                      
                    $output .= '<li class="item-cat item-cat-' . esc_attr($cat_id) . ' item-cat-' . esc_attr($cat_nicename) . '"><a class="bread-cat bread-cat-' . esc_attr($cat_id) . ' bread-cat-' . esc_attr($cat_nicename) . '" href="' . esc_url($cat_link) . '" title="' . esc_attr($cat_name) . '">' . esc_html($cat_name) . '</a></li>';
                    $output .= '<li class="separator"> ' . $separator . ' </li>';
                    $output .= '<li class="item-current item-' . esc_attr($post->ID) . '"><div class="bread-current bread-' . esc_attr($post->ID) . '" title="' . esc_attr(get_the_title()) . '">' . esc_html(get_the_title()) . '</div></li>';
                  
                } else {
                      
                    $output .= '<li class="item-current item-' . esc_attr($post->ID) . '"><div class="bread-current bread-' . esc_attr($post->ID) . '" title="' . esc_attr(get_the_title()) . '">' . esc_html(get_the_title()) . '</div></li>';
                      
                }
                  
            } else if ( is_category() ) {
                // Category page
                $output .= '<li class="item-current item-cat"><div class="bread-current bread-cat">' . single_cat_title('', false) . '</div></li>';
                   
            } else if ( is_page() ) {
                // Standard page
                if( $post->post_parent ){
                       
                    // If child page, get parents 
                    $anc = get_post_ancestors( $post->ID );
                       
                    // Get parents in the right order
                    $anc = array_reverse($anc);
                       
                    // Parent page loop
                    if ( !isset( $parents ) ) $parents = null;
                    foreach ( $anc as $ancestor ) {
                        $parents .= '<li class="item-parent item-parent-' . esc_attr($ancestor) . '"><a class="bread-parent bread-parent-' . esc_attr($ancestor) . '" href="' . esc_url( get_permalink($ancestor) ) . '" title="' . esc_attr( get_the_title($ancestor) ) . '">' . esc_html( get_the_title($ancestor) ) . '</a></li>';
                        $parents .= '<li class="separator separator-' . esc_attr($ancestor) . '"> ' . $separator . ' </li>';
                    }
                       
                    // Display parent pages
                    $output .= $parents;
                       
                    // Current page
                    $output .= '<li class="item-current item-' . esc_attr($post->ID) . '"><strong title="' . esc_attr(get_the_title()) . '"> ' . esc_html(get_the_title()) . '</strong></li>';
                       
                } else {
                       
                    // Just display current page if not parents
                    $output .= '<li class="item-current item-' . esc_attr($post->ID) . '"><div class="bread-current bread-' . esc_attr($post->ID) . '"> ' . esc_html(get_the_title()) . '</div></li>';
                       
                }
                   
            } else if ( is_tag() ) {
                // Tag page
                   
                // Get tag information
                $term_id        = get_query_var('tag_id');
                $taxonomy       = 'post_tag';
                $args           = 'include=' . $term_id;
                $terms          = get_terms( $taxonomy, $args );
                $get_term_id    = $terms[0]->term_id;
                $get_term_slug  = $terms[0]->slug;
                $get_term_name  = $terms[0]->name;
                   
                // Display the tag name
                $output .= '<li class="item-current item-tag-' . esc_attr($get_term_id) . ' item-tag-' . esc_attr($get_term_slug) . '"><div class="bread-current bread-tag-' . esc_attr($get_term_id) . ' bread-tag-' . esc_attr($get_term_slug) . '">' . esc_html($get_term_name) . '</div></li>';
               
            } elseif ( is_day() ) {
                   
                // Day archive
                   
                // Year link
                $output .= '<li class="item-year item-year-' . get_the_time('Y') . '"><a class="bread-year bread-year-' . get_the_time('Y') . '" href="' . get_year_link( get_the_time('Y') ) . '" title="' . get_the_time('Y') . '">' . get_the_time('Y') . ' '. esc_html__('Archives', 'aat-cbreadcrumbs') . '</a></li>';
                $output .= '<li class="separator separator-' . get_the_time('Y') . '"> ' . $separator . ' </li>';
                   
                // Month link
                $output .= '<li class="item-month item-month-' . get_the_time('m') . '"><a class="bread-month bread-month-' . get_the_time('m') . '" href="' . get_month_link( get_the_time('Y'), get_the_time('m') ) . '" title="' . get_the_time('M') . '">' . get_the_time('M') . ' '. esc_html__('Archives', 'aat-cbreadcrumbs') . '</a></li>';
                $output .= '<li class="separator separator-' . get_the_time('m') . '"> ' . $separator . ' </li>';
                   
                // Day display
                $output .= '<li class="item-current item-' . get_the_time('j') . '"><div class="bread-current bread-' . get_the_time('j') . '"> ' . get_the_time('jS') . ' ' . get_the_time('M') . ' '. esc_html__('Archives', 'aat-cbreadcrumbs') . '</div></li>';
                   
            } else if ( is_month() ) {
                   
                // Month Archive
                   
                // Year link
                $output .= '<li class="item-year item-year-' . get_the_time('Y') . '"><a class="bread-year bread-year-' . get_the_time('Y') . '" href="' . get_year_link( get_the_time('Y') ) . '" title="' . get_the_time('Y') . '">' . get_the_time('Y') . ' '. esc_html__('Archives', 'aat-cbreadcrumbs') . '</a></li>';
                $output .= '<li class="separator separator-' . get_the_time('Y') . '"> ' . $separator . ' </li>';
                   
                // Month display
                $output .= '<li class="item-month item-month-' . get_the_time('m') . '"><strong class="bread-month bread-month-' . get_the_time('m') . '" title="' . get_the_time('M') . '">' . get_the_time('M') . ' '. esc_html__('Archives', 'aat-cbreadcrumbs') . '</strong></li>';
                   
            } else if ( is_year() ) {
                   
                // Display year archive
                $output .= '<li class="item-current item-current-' . get_the_time('Y') . '"><div class="bread-current bread-current-' . get_the_time('Y') . '" title="' . get_the_time('Y') . '">' . get_the_time('Y') . ' '. esc_html__('Archives', 'aat-cbreadcrumbs') . '</div></li>';
                   
            } else if ( is_author() ) {
                   
                // Auhor archive
                   
                // Get the author information
                global $author;
                $userdata = get_userdata( $author );
                   
                // Display author name
                $output .= '<li class="item-current item-current-' . esc_attr($userdata->user_nicename) . '"><div class="bread-current bread-current-' . esc_attr($userdata->user_nicename) . '" title="' . esc_attr($userdata->display_name) . '">' . esc_html__('Author: ', 'aat-cbreadcrumbs') . esc_html($userdata->display_name) . '</div></li>';
               
            } else if ( get_query_var('paged') ) {
                // Paginated archives
                $output .= '<li class="item-current item-current-' . esc_attr(get_query_var('paged')) . '"><div class="bread-current bread-current-' . esc_attr(get_query_var('paged')) . '" title="'. esc_html__('Page', 'aat-cbreadcrumbs') .' ' . esc_attr(get_query_var('paged')) . '">'.esc_html__('Page', 'aat-cbreadcrumbs') . ' ' . get_query_var('paged') . '</div></li>';
                   
            } else if ( is_search() ) {
                // Search results page
                $output .= '<li class="item-current item-current-' . esc_attr(get_search_query()) . '"><div class="bread-current bread-current-' . esc_attr(get_search_query()) . '" title="Search results for: ' . esc_attr(get_search_query()) . '">' . esc_html__('Search results for:', 'aat-cbreadcrumbs') .' ' . esc_html(get_search_query()) . '</div></li>';
               
            } elseif ( is_404() ) {
                   
                // 404 page
                $output .= '<li>' . esc_html__('Error 404', 'aat-cbreadcrumbs') . '</li>';
            }

           
            $output .= '</ul>';

            $output .= '<div class="cb-breadcrumbs-overlay"></div>';

        $output .= '</div>';

        

        if ( ( isset( $this->settings['custom_css_selector'] ) && trim( $this->settings['custom_css_selector'] ) != '' ) || ( isset( $this->settings['custom_css_woocommerce_selector'] ) && trim( $this->settings['custom_css_woocommerce_selector'] ) != '' ) || ( $this->current_theme->get('TextDomain') == 'kingdom' || $this->current_theme->get('TextDomain') == 'bravostore' || $this->current_theme->get('TextDomain') == 'Avada' ) ){
            $this->custom_breadcrumbs_replace( $output );
        }
        else {
            echo $output;
        }
       
    }
       
}

    public function loadExtraStyles()
    {
        wp_enqueue_style( 'cb-moonicon-css', cb()->path('ASSETS_URL') . '/moon-icons.css', array(), '1.0' );
        wp_enqueue_style( 'cb-font-awesome', cb()->path('ASSETS_URL') . '/font-awesome.min.css', array(), '1.0' );
        wp_enqueue_style( 'cb-heebo-font', 'https://fonts.googleapis.com/css?family=Heebo', array(), '1.0' );
        wp_enqueue_script( 'cb-frontend-js', cb()->path('ASSETS_URL') . '/frontend.js', array('jquery'), '1.0', true );
        wp_enqueue_script( 'cb-css-selector-picker-js', cb()->path('ASSETS_URL') . '/css_picker.js', array('jquery'), '1.0', true );
        wp_enqueue_style( 'cb-picker-css', cb()->path('ASSETS_URL') . '/css_picker.css', array(), '1.0' );


        $cbCssPickerUtils = array( 'cb_ajax_url' => admin_url( 'admin-ajax.php' ), 'cb_settings_url' => admin_url( 'admin.php?page=cb&cb_action=config' ) );
        wp_localize_script( 'cb-css-selector-picker-js', 'cb_css_picker_utils', $cbCssPickerUtils );


    }

    public function custom_breadcrumbs_replace( $breadcrumbs_array )
    {

        $breadcrumbs_links = array();

        $breadcrumbs_links['current_theme'] = $this->current_theme->get('TextDomain');

        if (  trim( $this->settings['custom_css_selector'] ) == '' && trim( $this->settings['custom_css_woocommerce_selector'] ) == '' ) {

            switch( $breadcrumbs_links['current_theme'] ) {
                case 'kingdom':
                    $breadcrumbs_links['selector'] = '#crumbs';
                    break;
                case 'bravostore':
                    $breadcrumbs_links['selector'] = '.aa-breadcrumbs-container';
                    break;
                case 'Avada':
                    $breadcrumbs_links['selector'] = '.fusion-breadcrumbs';
                    break;
            }
        }
        else {
            $breadcrumbs_links['selector'] = $this->settings['custom_css_selector'];
            $breadcrumbs_links['woo_selector'] = $this->settings['custom_css_woocommerce_selector'];
        }

        $breadcrumbs_links['breadcrumbs_array'] = $breadcrumbs_array;
        

        wp_localize_script( 'cb-frontend-js', 'cb_custom_css_selector', $breadcrumbs_links );

    }


}